# Simple ecBuild project

## Contents

The project contains two directories. The `circle` directory contains a Fortran
library and a C test of the library. The `compute` directory contains a C++
executable linking to the `circle` library as well as to LAPACK and GSL, if
they can be found on the system.

## Pointing to the libraries

The FindLAPACK macro provided by CMake looks for LAPACK in the system dynamic
linker environment variables:
* `DYLD_LIBRARY_PATH` on Apple
* `LIB` on Windows
* `LD_LIBRARY_PATH` otherwise

The FindGSL macro provided by CMake looks for the `GSL_ROOT_DIR` environment
variable. The libraries are expected to be in `$GSL_ROOT_DIR/lib` and the
headers in `$GSL_ROOT_DIR/include/gsl`. On Unix, the
`$GSL_ROOT_DIR/bin/gsl-config` tool will be used if it exists.

## Usage

```
SRC_DIR=$PWD # Source directory containing the main CMakeLists.txt
BUILD_DIR=$PWD/build # Out-of-source build directory
cd $BUILD_DIR
ecbuild $SRC_DIR
make -j
ctest
```

# Handle CMAKE_*_DEPRECATED

Since CMake 4.4, and according to the CMake policy CMP0218, the non-cached variables
CMAKE_WARN_DEPRECATED and CMAKE_ERROR_DEPRECATED are essentially ignored. Instead, the
new policy uses cmake_diagnostic/CMD_DEPRECATED to control the behaviour of deprecated
features. From CMake 4.4 onwards, if any of the CMAKE_*_DEPRECATED variables are set
while CMP0218 is unset, CMake issues a policy warning.

This example configures a project that uses ecbuild, and ensures that no policy warning
is issued during the configuration phase. A second project ensures that project code
still issue policy warning.

## Usage

The test is normally run through CTest:

    ctest -R test_ecbuild_handle_deprecated

It can also be run directly, in which case the project is configured in a temporary
directory that is removed on exit:

    ./build.sh

find_package test projects

The projects/ directory contains test projects for specific libraries. They
serve as examples but can also be used to check these libraries by running the
find_*.sh scripts.

# Config-bundle with separate configuration for subproj2

    SRC_DIR=$(pwd)
    BUILD_DIR=$(pwd)/build
    mkdir -p ${BUILD_DIR} && cd ${BUILD_DIR}

    ../../../bin/ecbuild --build=debug --log=debug --config=${SRC_DIR}/general_config.cmake -- -DSUBPROJ2_CONFIG=${SRC_DIR}/subproj2_config.cmake ${SRC_DIR}

# Transitive dependencies across projects and using ecbuild_find_package

This example contains 3 projects, where projectB depends on projectA, and
projectC depends on projectB. Since projectB requires linking against projectA,
the `projectB/projectb-import.cmake.in` file propagates the dependency (it gets
included when a package calls `find_package(projectB)`). It also demonstrates
PRIVATE (build requirements) and PUBLIC (usage requirements) dependency
keywords.

projectC searches for projectB using a FindprojectB module, which in turn uses a find_package( projectB NO_MODULE )
This demonstrates that ecbuild_find_package now prioritises Find modules.

## Usage

./build-and-run.sh

# Transitive dependencies across projects

This example contains 3 projects, where projectB depends on projectA, and
projectC depends on projectB. Since projectB requires linking against projectA,
the `projectB/projectb-import.cmake.in` file propagates the dependency (it gets
included when a package calls `find_package(projectB)`). It also demonstrates
PRIVATE (build requirements) and PUBLIC (usage requirements) dependency
keywords.

## Usage

./build-and-run.sh

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This is a very simple example which writes a 2D array of
!     sample data. To handle this in netCDF we create two shared
!     dimensions, "x" and "y", and a netCDF variable, called "data".

!     This example demonstrates the netCDF Fortran 90 API. This is part
!     of the netCDF tutorial, which can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
!     Full documentation of the netCDF Fortran 90 API can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

!     $Id: simple_xy_wr.f90,v 1.7 2006/12/09 18:44:58 russ Exp $

program simple_xy_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "simple_xy.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: NDIMS = 2
  integer, parameter :: NX = 6, NY = 12

  ! When we create netCDF files, variables and dimensions, we get back
  ! an ID for each one.
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid
  
  ! This is the data array we will write. It will just be filled with
  ! a progression of integers for this example.
  integer :: data_out(NY, NX)

  ! Loop indexes, and error handling.
  integer :: x, y

  ! Create some pretend data. If this wasn't an example program, we
  ! would have some real data to write, for example, model output.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Always check the return code of every netCDF function call. In
  ! this example program, wrapping netCDF calls with "call check()"
  ! makes sure that any return which is not equal to nf90_noerr (0)
  ! will print a netCDF error message and exit.

  ! Create the netCDF file. The nf90_clobber parameter tells netCDF to
  ! overwrite this file, if it already exists.
  call check( nf90_create(FILE_NAME, NF90_CLOBBER, ncid) )

  ! Define the dimensions. NetCDF will hand back an ID for each. 
  call check( nf90_def_dim(ncid, "x", NX, x_dimid) )
  call check( nf90_def_dim(ncid, "y", NY, y_dimid) )

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer).
  call check( nf90_def_var(ncid, "data", NF90_INT, dimids, varid) )

  ! End define mode. This tells netCDF we are done defining metadata.
  call check( nf90_enddef(ncid) )

  ! Write the pretend data to the file. Although netCDF supports
  ! reading and writing subsets of data, in this case we write all the
  ! data in one operation.
  call check( nf90_put_var(ncid, varid, data_out) )

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  print *, "*** SUCCESS writing example file simple_xy.nc! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop "Stopped"
    end if
  end subroutine check  
end program simple_xy_wr

! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
!   Copyright by The HDF Group.                                               *
!   Copyright by the Board of Trustees of the University of Illinois.         *
!   All rights reserved.                                                      *
!                                                                             *
!   This file is part of HDF5.  The full HDF5 copyright notice, including     *
!   terms governing use, modification, and redistribution, is contained in    *
!   the COPYING file, which can be found at the root of the source code       *
!   distribution tree, or in https://support.hdfgroup.org/ftp/HDF5/releases.  *
!   If you do not have access to either file, you may request a copy from     *
!   help@hdfgroup.org.                                                        *
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

!
! This file contains a FORTRAN90 example for the H5LT API
!
!
program lite_example


use H5LT ! module of H5LT
use HDF5 ! module of HDF5 library

implicit none

integer, parameter :: DIM1 = 4;                      ! Dimension of array
character(len=9), parameter :: filename = "exlite.h5"! File name
character(LEN=5), parameter :: dsetname1 = "dset1"   ! Dataset name
integer(HID_T) :: file_id                            ! File identifier
integer(HSIZE_T), dimension(1) :: dims = (/DIM1/)    ! Dataset dimensions
integer        :: rank = 1                           ! Dataset rank
integer, dimension(DIM1) :: buf1                     ! Data buffer
integer, dimension(DIM1) :: bufr1                    ! Data buffer
integer        :: errcode                            ! Error flag
integer        :: i                                  ! general purpose integer


!
! Initialize the data array.
!

do i = 1, DIM1
  buf1(i) = i;
end do

!
! Initialize FORTRAN predefined datatypes.
!

call h5open_f(errcode)

!
! Create a new file using default properties.
!

call h5fcreate_f(filename, H5F_ACC_TRUNC_F, file_id, errcode)

!
! write dataset.
!

call h5ltmake_dataset_f(file_id, dsetname1, rank, dims, H5T_NATIVE_INTEGER, buf1, errcode)

!
! read dataset.
!

call h5ltread_dataset_f(file_id, dsetname1, H5T_NATIVE_INTEGER, bufr1, dims, errcode)

!
! compare read and write buffers.
!

do i = 1, DIM1
 if ( buf1(i) .ne. bufr1(i) ) then
   print *, 'read buffer differs from write buffer'
   print *,  bufr1(i), ' and ',   buf1(i)
   stop
  endif
end do


!
! Close the file.
!

call h5fclose_f(file_id, errcode)


!
! Close FORTRAN predefined datatypes.
!

call h5close_f(errcode)

!
! end
!

end program lite_example

program main
    use mpi, only : MPI_Initialized
    implicit none
    integer :: ierror
    logical :: flag
    call MPI_Initialized(flag, ierror)
    write(0,*) "MPI initialized: ", flag
end program

! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
!  Copyright by The HDF Group.                                              *
!  Copyright by the Board of Trustees of the University of Illinois.        *
!  All rights reserved.                                                     *
!                                                                           *
!  This file is part of HDF5.  The full HDF5 copyright notice, including    *
!  terms governing use, modification, and redistribution, is contained in   *
!   the COPYING file, which can be found at the root of the source code       *
!   distribution tree, or in https://support.hdfgroup.org/ftp/HDF5/releases.  *
!   If you do not have access to either file, you may request a copy from     *
!   help@hdfgroup.org.                                                        *
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
!
! This example shows how to write and read a hyperslab.  
! It is used in the HDF5 Tutorial.
!

PROGRAM H5_SUBSET 

  USE HDF5 ! This module contains all necessary modules 

  IMPLICIT NONE

  CHARACTER(LEN=9), PARAMETER :: filename = "subset.h5"  ! File name
  CHARACTER(LEN=8), PARAMETER :: dsetname = "IntArray"   ! Dataset name

  INTEGER(HID_T) :: file_id       ! File identifier 
  INTEGER(HID_T) :: dset_id       ! Dataset identifier 
  INTEGER(HID_T) :: dataspace     ! Dataspace identifier 
  INTEGER(HID_T) :: memspace      ! memspace identifier 

  !
  ! To change the subset size, modify size of dimsm, sdata, dim0_sub,
  ! dim1_sub, and count
  !
  INTEGER(HSIZE_T), DIMENSION(1:2) :: dimsm = (/4,3/) ! Dataset dimensions
  INTEGER, DIMENSION(1:4,1:3) :: sdata                  ! Subset buffer
  INTEGER :: dim0_sub = 4   
  INTEGER :: dim1_sub = 3 
  INTEGER(HSIZE_T), DIMENSION(1:2) :: count = (/4,3/)  ! Size of hyperslab
  INTEGER(HSIZE_T), DIMENSION(1:2) :: offset = (/2,1/) ! Hyperslab offset
  INTEGER(HSIZE_T), DIMENSION(1:2) :: stride = (/1,1/) ! Hyperslab stride 
  INTEGER(HSIZE_T), DIMENSION(1:2) :: block = (/1,1/)  ! Hyperslab block size 

  INTEGER(HSIZE_T), DIMENSION(1:2) :: dimsf = (/10,8/) ! Dataset dimensions


  INTEGER, DIMENSION(1:10,1:8) :: data     ! Data to write
  INTEGER, DIMENSION(1:10,1:8) :: rdata    ! Data to read 

  INTEGER :: rank = 2      ! Dataset rank ( in file )
  INTEGER :: dim0 = 10     ! Dataset size in file
  INTEGER :: dim1 = 8 

  INTEGER :: i, j 

  INTEGER :: error         ! Error flag
  INTEGER(HSIZE_T), DIMENSION(2) :: data_dims

  !
  ! Write data to the HDF5 file.  
  !

  !
  ! Data initialization. 
  !
  DO i = 1, dim0 
     DO j = 1, dim1
        IF (i .LE. (dim0 / 2)) THEN
           data(i,j) = 1 
        ELSE 
           data(i,j) = 2 
        END IF
     END DO
  END DO

  !
  ! Initialize FORTRAN interface. 
  !
  CALL h5open_f(error) 

  !
  ! Create a new file using default properties.
  ! 
  CALL h5fcreate_f(filename, H5F_ACC_TRUNC_F, file_id, error)

  !
  ! Create the data space for the  dataset. 
  !
  CALL h5screate_simple_f(rank, dimsf, dataspace, error)

  !
  ! Create the dataset with default properties.
  !
  CALL h5dcreate_f(file_id, dsetname, H5T_NATIVE_INTEGER, dataspace, &
       dset_id, error)

  !
  ! Write the dataset.
  !
  data_dims(1) = dim0 
  data_dims(2) = dim1 
  CALL h5dwrite_f(dset_id, H5T_NATIVE_INTEGER, data, data_dims, error)

  !
  ! Data Written to File 
  !
  WRITE(*,'(/,A)') "Original Data Written to File:"
  DO i = 1, dim0
     WRITE(*,'(100(1X,I0,1X))') DATA(i,1:dim1)
  END DO

  !
  !
  ! Close the dataspace, dataset, and file.
  !
  CALL h5sclose_f(dataspace, error)
  CALL h5dclose_f(dset_id, error)
  CALL h5fclose_f(file_id, error)

  !
  ! Initialize subset data array.
  !
  sdata(1:dim0_sub,1:dim1_sub) = 5

  !
  ! Open the file.
  !
  CALL h5fopen_f(filename, H5F_ACC_RDWR_F, file_id, error)

  !
  ! Open the  dataset.
  !
  CALL h5dopen_f(file_id, dsetname, dset_id, error)

  !
  ! Get dataset's dataspace identifier and select subset.
  !
  CALL h5dget_space_f(dset_id, dataspace, error)
  CALL h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, &
       offset, count, error, stride, BLOCK) 
  !
  ! Create memory dataspace.
  !
  CALL h5screate_simple_f(rank, dimsm, memspace, error)

  WRITE(*,'(/,A)') "Write subset to file specifying:"
  WRITE(*,'(A,/)') "   offset=2x1 stride=1x1 count=4x3 block=1x1"

  !
  ! Write subset to dataset  
  !
  data_dims(1:2) = (/dim0_sub, dim1_sub/) 
  CALL h5dwrite_f(dset_id, H5T_NATIVE_INTEGER, sdata, data_dims, error, &
       memspace, dataspace)

  data_dims(1:2) = (/dim0, dim1/)
  CALL h5dread_f(dset_id, H5T_NATIVE_INTEGER, rdata, data_dims, error)

  !
  ! Read entire dataset back 
  !
  WRITE(*,'(A)') "Data in File after Subset Written:"
  DO i = 1, dim0 
    WRITE(*,'(100(1X,I0,1X))') rdata(i,1:dim1)
  END DO
  PRINT *, " "

  !
  ! Close everything opened.
  !
  CALL h5sclose_f(dataspace, error)
  CALL h5sclose_f(memspace, error)
  CALL h5dclose_f(dset_id, error)
  CALL h5fclose_f(file_id, error)

  !
  ! Close FORTRAN interface.
  !
  CALL h5close_f(error)

END PROGRAM H5_SUBSET

!-----Area_Circle----------------------------------------------------
!
!  Function to compute the area of a circle of given radius
!
!---------------------------------------------------------------------
FUNCTION Area_Circle(r)
USE Circle, ONLY : Pi

IMPLICIT NONE
REAL :: Area_Circle
REAL, INTENT(IN) :: r

Area_Circle = Pi * r * r

END FUNCTION Area_Circle

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is a very simple example which writes a 2D array of
C     sample data. To handle this in netCDF we create two shared
C     dimensions, "x" and "y", and a netCDF variable, called "data".

C     This example demonstrates the netCDF Fortran 77 API. This is part
C     of the netCDF tutorial, which can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: simple_xy_wr.f,v 1.9 2007/01/24 19:45:09 russ Exp $

      program simple_xy_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy.nc')

C     We are writing 2D data, a 6 x 12 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     When we create netCDF files, variables and dimensions, we get back
C     an ID for each one.
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid

C     This is the data array we will write. It will just be filled with
C     a progression of integers for this example.
      integer data_out(NY, NX)

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data. If this wasn't an example program, we
C     would have some real data to write, for example, model output.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

C     Always check the return code of every netCDF function call. In
C     this example program, any retval which is not equal to nf_noerr
C     (0) will call handle_err, which prints a netCDF error message, and
C     then exits with a non-zero return code.

C     Create the netCDF file. The nf_clobber parameter tells netCDF to
C     overwrite this file, if it already exists.
      retval = nf_create(FILE_NAME, NF_CLOBBER, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions. NetCDF will hand back an ID for each. 
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the IDs of the dimensions of
C     the variables. Note that in fortran arrays are stored in
C     column-major format.
      dimids(2) = x_dimid
      dimids(1) = y_dimid

C     Define the variable. The type of the variable in this case is
C     NF_INT (4-byte integer).
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode. This tells netCDF we are done defining metadata.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data to the file. Although netCDF supports
C     reading and writing subsets of data, in this case we write all the
C     data in one operation.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file. This frees up any internal netCDF resources
C     associated with the file, and flushes any buffers.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS writing example file simple_xy.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}

# --------------------- cleanup ------------------------
echo "cleaning $HERE"
rm -rf $HERE/projectA/build
rm -rf $HERE/projectA/install
rm -rf $HERE/projectB/build
rm -rf $HERE/projectB/install
rm -rf $HERE/projectC/build
rm -rf $HERE/projectC/install

#!/usr/bin/env bash

set -euo pipefail

SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-"$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd -P )"}

# When not launched by CTest, build in a temporary directory, to avoid polluting the source tree
if [[ -n "${CMAKE_CURRENT_BINARY_DIR:-}" ]]; then
    HERE=${CMAKE_CURRENT_BINARY_DIR}
else
    HERE=$(mktemp -d)
    trap 'rm -rf "${HERE}"' EXIT
fi

# Add ecbuild to path
export PATH="${SOURCE}/../../bin:${PATH}"

# ----------------- CMake version ----------------------

CMAKE_VERSION=$(cmake --version | head -1 | awk '{print $3}')

IFS=. read -r CMAKE_MAJOR_VERSION CMAKE_MINOR_VERSION _ <<< "$CMAKE_VERSION"

# --------------------- cleanup ------------------------
[[ -n "${HERE}" ]] || { echo "error: build directory is not set" >&2; exit 1; }
rm -rf "${HERE}/projectA/build"
rm -rf "${HERE}/projectB/build"

# ----------------- build projectA ---------------------

mkdir -p "${HERE}/projectA/build" && cd "${HERE}/projectA/build"
BUILD_LOG="${HERE}/projectA/build/ecbuild.log"
ecbuild "${SOURCE}/projectA" 2>&1 | tee "${BUILD_LOG}"

if grep -q 'Policy CMP0218 is not set' "${BUILD_LOG}"; then
    echo "error: Unexpected reference to CMP0218 found in '${BUILD_LOG}'" >&2
    exit 1
fi

# ----------------- build projectB ---------------------

if (( CMAKE_MAJOR_VERSION > 4 || (CMAKE_MAJOR_VERSION == 4 && CMAKE_MINOR_VERSION >= 4) )); then

    # This test can only be run if using CMake 4.4+, which actually enforces Policy CMP0218
    #
    # Important: This test will need to be reviewed/removed, if CMake updates its behaviour
    #            and stops producing the deprecation message.

    mkdir -p "${HERE}/projectB/build" && cd "${HERE}/projectB/build"
    BUILD_LOG="${HERE}/projectB/build/ecbuild.log"
    ecbuild "${SOURCE}/projectB" 2>&1 | tee "${BUILD_LOG}"

    if ! grep -q 'Policy CMP0218 is not set' "${BUILD_LOG}"; then
        echo "error: Could not find reference to CMP0218 in '${BUILD_LOG}'" >&2
        exit 1
    fi

else
    echo "Note: skipping projectB (requires CMake 4.4+, found ${CMAKE_VERSION})"
fi

#!/usr/bin/env bash

set -euo pipefail

ECBUILD_PATH=${CMAKE_SOURCE_DIR}/bin
SOURCE_TEST_DIR=${CMAKE_CURRENT_SOURCE_DIR}
BINARY_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}

#
# Redirect HOME to a per-job temp directory so that every git process
# (including subprocesses spawned internally by git-submodule) reads a private
# ~/.gitconfig. This avoids lock contention on the real ~/.gitconfig when
# parallel CI jobs run, and works on all git versions.
#
# GIT_CONFIG_GLOBAL (requires git >= 2.32) and GIT_CONFIG_COUNT (not forwarded
# by git-submodule to its child processes) are not viable alternatives here.
#
# Required on git >= 2.38.1 and on distros that have backported CVE-2022-39253
# (e.g. Debian 11's git 2.30.2).
#
_tmp_home=$(mktemp -d)
export HOME="${_tmp_home}"
trap 'rm -rf "${_tmp_home}"' EXIT
pushd "${HOME}" > /dev/null
git config --global protocol.file.allow always
git config --global user.name  "Test User"
git config --global user.email "test@user"
popd > /dev/null

# Add ecbuild to path
export PATH=$ECBUILD_PATH:$PATH

# ---- cleanup -----------------------------------------
[[ -n "${BINARY_TEST_DIR}" ]] || { echo "BINARY_TEST_DIR is not set"; exit 1; }
rm -rf "${BINARY_TEST_DIR}/workspace"

# ---- setup umbrella project (with submodules) --------
cd "${BINARY_TEST_DIR}"
bash "${SOURCE_TEST_DIR}/setup-umbrella-project.sh" \
          "${BINARY_TEST_DIR}/workspace/projects"

# ---- setup umbrella bundle ---------------------------
cd "${BINARY_TEST_DIR}"
bash "${SOURCE_TEST_DIR}/setup-umbrella-bundle.sh" \
          "${BINARY_TEST_DIR}/workspace/bundle" \
          "${BINARY_TEST_DIR}/workspace/projects/umbrella"

# ---- configure umbrella bundle -----------------------
cd ${BINARY_TEST_DIR}/workspace
mkdir build
cd build
ecbuild --prefix=$(pwd)/install -- ../bundle

# ---- check shallowness (umbrella + submodules) -------
PASS=1

cd "${BINARY_TEST_DIR}/workspace/bundle/umbrella"
if [[ "$(git rev-parse --is-shallow-repository)" != "true" ]]; then
    echo "Umbrella is not shallow: FAIL"
    PASS=0
else
    echo "Umbrella is shallow: PASS"
fi

for sub in alpha beta gamma; do
    cd "${BINARY_TEST_DIR}/workspace/bundle/umbrella/${sub}"
    if [[ "$(git rev-parse --is-shallow-repository)" != "true" ]]; then
        echo "Submodule $sub is not shallow: FAIL"
        PASS=0
    else
        echo "Submodule $sub is shallow: PASS"
    fi
done

exit $(( 1 - PASS ))

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep -e "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# (0) Options: (default)
#      proja, FEATURE_A is enabled (by default)
#      projb, FEATURE_A is disabled (by default)

TC=0

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

# (1) Options: -DSOME_PACKAGE_FOUND
#      proja, FEATURE_A is enabled (by default)
#      projb, FEATURE_A is disabled (by default), event if the conditional package is found

TC=1

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DSOME_PACKAGE_FOUND=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

# (2) Options: -DENABLE_FEATURE_A=ON
#      proja, FEATURE_A is explicitly enabled (by global option)
#      projb, FEATURE_A is explicitly enabled (by global option), but fails since the conditional package is not found

TC=2

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log " Configuring incomplete, errors occurred"

# (3) Options: -DENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON
#      proja, FEATURE_A is explicitly enabled (by global option)
#      projb, FEATURE_A is explicitly enabled (by global option), and succeeds because the conditional package is found

TC=3

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

# (4) Options: -DENABLE_FEATURE_A=OFF
#      proja, FEATURE_A is explicitly disabled (by global option)
#      projb, FEATURE_A is explicitly disabled (by global option)

TC=4

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=OFF -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

# (5) Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON
#      proja, FEATURE_A is explicitly disabled (by global option)
#      projb, FEATURE_A is explicitly enabled (by project-specific option), but fails since the conditional package is not found

TC=5

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log " Configuring incomplete, errors occurred"

# (6) Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON
#      proja, FEATURE_A is explicitly disabled (by global option)
#      projb, FEATURE_A is explicitly enabled (by project-specific option), possible because the conditional package is found

TC=6

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

# (7) Options: -DENABLE_FEATURE_A=ON -DPROJA_ENABLE_FEATURE_A=OFF
#      proja, FEATURE_A is explicitly disabled (by project-specific option)
#      projb, FEATURE_A is explicitly enabled (by global option), but fails since the conditional package is not found

TC=7

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=ON -DPROJA_ENABLE_FEATURE_A=OFF -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log " Configuring incomplete, errors occurred"

# (8) Options: -DENABLE_FEATURE_A=ON -DPROJB_ENABLE_FEATURE_A=OFF -DSOME_PACKAGE_FOUND=ON
#      proja, FEATURE_A is explicitly enabled (by global option)
#      projb, FEATURE_A is explicitly disabled (by project-specific option), event if the conditional package is found

TC=8

mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/projx -DENABLE_FEATURE_A=ON -DPROJB_ENABLE_FEATURE_A=OFF -DSOME_PACKAGE_FOUND=ON -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*proja(ON): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "FEATURE_A, .*projb(OFF): ''.*"
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

run_test() {

    local tname=$1
    local exp_sts=$2
    shift 2

    local bdir=$HERE/build_$tname
    local idir=$HERE/install_$tname
    local logf=$HERE/$tname.log

    mkdir -p $bdir && cd $bdir
    local sts=0
    echo "Running test '$tname'"
    ecbuild --prefix=$idir  -- -Wno-deprecated $* $SOURCE/test_project >$logf 2>&1 || sts=$?

    make install

    if [[ $sts -ne $exp_sts ]] ; then
        echo "Test '$tname': expected exit code $exp_sts, got $sts"
        cat $logf
        exit 1
    fi
}

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ---------------------- tests -------------------------
run_test test_interface_library 0

#!/bin/bash

[[ $(uname) == "Darwin" ]] && return # no module environment on the Mac

# initialise module environment if it is not
if [[ ! $(command -v module > /dev/null 2>&1) ]]; then
  . /usr/local/apps/module/init/bash
fi

module load cmake/new

#!/bin/bash

#[[ $(uname) == "Darwin" ]] && return # no module environment on the Mac

# initialise module environment if it is not
#if [[ ! $(command -v module > /dev/null 2>&1) ]]; then
#  . /usr/local/apps/module/init/bash
#fi

#module load cmake/new

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# Build the project
ecbuild $SOURCE/test_project -B $HERE/build

# Run only one specific test (which should invoke the dependencies)
(cd $HERE/build; ctest -R write_world_after_hello)  # Avoid using --test-dir option in ctest

# Check if the output is as expected
echo -n "Hello, World!" | diff - $HERE/build/output.txt

#!/bin/bash

# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

chksm="md5sum"
manifest_file="manifest.txt"
install_proc="echo_install"

#------------------------------------------------------------------------------

function abspath {
    if [[ -d "$1" ]]
    then
        pushd "$1" >/dev/null
        pwd
        popd >/dev/null
    elif [[ -e $1 ]]
    then
        pushd $(dirname $1) >/dev/null
        echo $(pwd)/$(basename $1)
        popd >/dev/null
    else
        echo "error: path $1 does not exist!" >&2
        return 127
    fi
}

function echo_install {
  echo "$1 -> $2"
}

#------------------------------------------------------------------------------

if [ -z $2 ]
then
    echo "usage: $0 <src_dir> <target_dir>"
    exit 1
fi

[[ ! -z $3 ]] && install_proc="$3"

SRC=$(abspath $1)
TGT=$(abspath $2)

manifest="$SRC/$manifest_file"

#------------------------------------------------------------------------------

[[ ! -f $manifest ]] && echo "error: cannot find manifest.txt in dir $SRC" && exit 1

cd $SRC

for f in $(cat $manifest )
do

  [[ ! -f "$SRC/$f" ]] && echo "error: $SRC/$f does not exist" && exit 1

  install="no"

  if [[ ! -f "$TGT/$f" ]]
  then
    install="yes"
  else
    srcsum=$( $chksm "$SRC/$f" | cut -d" " -f1 )
    tgtsum=$( $chksm "$TGT/$f" | cut -d" " -f1 )

    if [ $srcsum != "$tgtsum" ]
    then
      install="yes"
    fi
  fi

   if [ $install == "yes" ]
   then
     $install_proc $SRC/$f $TGT/$f
   fi

done

#!/usr/bin/env bash

set -e
set -u
set -o pipefail

# ─────────────────────────────────────────────
# Configuration
# ─────────────────────────────────────────────
BASE_DIR="${1:-$(pwd)/bundle}"
UMBRELLA_DIR="${2:-$(pwd)/projects/umbrella}"

echo "==> Creating bundle workspace at: $BASE_DIR"
mkdir -p "$BASE_DIR"
cd "$BASE_DIR"

# ─────────────────────────────────────────────
# Create the umbrella bundle
# ─────────────────────────────────────────────

UMBRELLA_GIT="file://$(dirname "${UMBRELLA_DIR}")/../bare-repos/$(basename "${UMBRELLA_DIR}").git"

cat > CMakeLists.txt <<EOF

cmake_minimum_required(VERSION 3.18 FATAL_ERROR)

find_package( ecbuild 3.12 REQUIRED HINTS ${CMAKE_SOURCE_DIR} )

project( umbrella-bundle LANGUAGES NONE )

ecbuild_bundle_initialize()

ecbuild_bundle(
  PROJECT umbrella
  GIT "${UMBRELLA_GIT}"
  BRANCH main
  RECURSIVE
  SHALLOW
)

ecbuild_bundle_finalize()

EOF

cat > VERSION <<EOF
0.0.1
EOF

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# Options: (default)

mkdir -p $HERE/build_1
ecbuild $SOURCE/test_project -B $HERE/build_1 | tee $HERE/build_1.log
EXPECT_ONE_OF $HERE/build_1.log "FEATURE_A, proja(ON): '', projb(OFF): '', projc(OFF): ''"

# Options: -DENABLE_FEATURE_A=ON (fails because of projc depends on nonexisting package)

mkdir -p $HERE/build_2
ecbuild -DENABLE_FEATURE_A=ON $SOURCE/test_project -B $HERE/build_2 | tee $HERE/build_2.log
EXPECT_ONE_OF $HERE/build_2.log "Configuring incomplete, errors occurred!"

# Options: -DPROJB_ENABLE_FEATURE_A=ON

mkdir -p $HERE/build_3
ecbuild -DPROJB_ENABLE_FEATURE_A=ON $SOURCE/test_project -B $HERE/build_3 | tee $HERE/build_3.log
EXPECT_ONE_OF $HERE/build_3.log "FEATURE_A, proja(ON): '', projb(ON): '', projc(OFF): ''"

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- build projectA ---------------------

mkdir -p $HERE/projectA/build && cd $HERE/projectA/build
pwd
ecbuild --prefix=../install -- -Wno-deprecated $SOURCE/projectA
make install
export projectA_ROOT=$HERE/projectA/install

# ----------------- build projectB ---------------------

mkdir -p $HERE/projectB/build && cd $HERE/projectB/build
ecbuild --prefix=../install -- -Wno-deprecated $SOURCE/projectB
make install
export projectB_ROOT=$HERE/projectB/install

# ----------------- build projectC ---------------------

mkdir -p $HERE/projectC/build && cd $HERE/projectC/build
ecbuild --prefix=../install -- -Wno-deprecated $SOURCE/projectC
make install

# ----------------- Run ---------------------

$HERE/projectC/install/bin/main-C

#!/usr/bin/env bash

set -e
set -u
set -o pipefail

# ─────────────────────────────────────────────
# Configuration
# ─────────────────────────────────────────────
BASE_DIR="${1:-$(pwd)/projects}"

PROJECTS=(alpha beta gamma)
UMBRELLA="umbrella"

echo "==> Creating workspace at: $BASE_DIR"
mkdir -p "$BASE_DIR"
cd "$BASE_DIR"

# ─────────────────────────────────────────────
# Helper: make a commit
# ─────────────────────────────────────────────
commit() {
    git add -A
    git commit -m "$1"
}

# ─────────────────────────────────────────────
# Create the 3 dummy projects
# ─────────────────────────────────────────────
for proj in "${PROJECTS[@]}"; do
    echo ""
    echo "──> Setting up project: $proj"
    mkdir -p "$proj"
    cd "$proj"
    git init -b main
    git config --local user.email "demo@example.com"
    git config --local user.name  "Demo User"

    # Initial commit with README
    cat > README.md <<EOF
# Project $proj
EOF
    commit "Initial commit: add README"

    # Second commit — add a source file
    mkdir -p src
    cat > "src/$proj.sh" <<EOF
#!/usr/bin/env bash
echo "Hello from $proj!"
EOF
    chmod +x "src/$proj.sh"
    commit "Add src/$proj.sh"

    # Third commit — update README with usage
    cat >> README.md <<EOF
## Usage

\`\`\`bash
bash src/$proj.sh
\`\`\`
EOF
    commit "docs: add usage section to README"

    # Fourth commit — add a config file
    cat > config.env <<EOF
PROJECT_NAME=$proj
VERSION=0.1.0
ENABLED=true
EOF
    commit "Add config.env"

    echo "    $proj: $(git log --oneline | wc -l | tr -d ' ') commits"
    cd ..
done

# ─────────────────────────────────────────────
# Create the umbrella project with submodules
# ─────────────────────────────────────────────
echo ""
echo "──> Setting up umbrella project: $UMBRELLA"
mkdir -p "$UMBRELLA"
cd "$UMBRELLA"
git init -b main
git config --local user.email "demo@example.com"
git config --local user.name  "Demo User"

# Initial README
cat > README.md <<EOF
# Umbrella Project
EOF

cat > CMakeLists.txt <<EOF

cmake_minimum_required(VERSION 3.18 FATAL_ERROR)

project( umbrella LANGUAGES NONE )

EOF

commit "Initial commit: add README"

#
# IMPORTANT: create each project as a submodule using file:// URL to honor shallow clones (--depth 1).
#
BARE_DIR="$BASE_DIR/../bare-repos"
mkdir -p "$BARE_DIR"
for proj in "${PROJECTS[@]}"; do
    git clone --bare "$BASE_DIR/$proj" "$BARE_DIR/$proj.git" >/dev/null
    git -c protocol.file.allow=always submodule add "file://$BARE_DIR/$proj.git" "$proj"
done
commit "Add submodules: alpha, beta, gamma"

# A follow-up commit that records a pinned state
cat >> README.md <<EOF

## Notes

Submodule remotes point to local sibling directories for demo purposes.
Replace the URLs in \`.gitmodules\` with real remote URLs before sharing.
EOF
commit "docs: note about submodule remote URLs"

#
# IMPORTANT: bare repo to ensure shallow clone behavior is honored
#
git clone --bare "$(pwd)" "$BARE_DIR/$UMBRELLA.git" >/dev/null

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}

# --------------------- cleanup ------------------------
echo "cleaning $HERE"
rm -rf $HERE/build_* $HERE/*.log

#!/usr/bin/env bash

set -euo pipefail

ECBUILD_PATH=${CMAKE_SOURCE_DIR}/bin
BINARY_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}

#
# Redirect HOME to a per-job temp directory so that every git process
# (including subprocesses spawned internally by git-submodule) reads a private
# ~/.gitconfig. This avoids lock contention on the real ~/.gitconfig when
# parallel CI jobs run, and works on all git versions.
#
# GIT_CONFIG_GLOBAL (requires git >= 2.32) and GIT_CONFIG_COUNT (not forwarded
# by git-submodule to its child processes) are not viable alternatives here.
#
# Required on git >= 2.38.1 and on distros that have backported CVE-2022-39253
# (e.g. Debian 11's git 2.30.2).
#
_tmp_home=$(mktemp -d)
export HOME="${_tmp_home}"
trap 'rm -rf "${_tmp_home}"' EXIT
pushd "${HOME}" > /dev/null
git config --global protocol.file.allow always
git config --global user.name  "Test User"
git config --global user.email "test@user"
popd > /dev/null

# Add ecbuild to path
export PATH=$ECBUILD_PATH:$PATH

# ---- cleanup -----------------------------------------
[[ -n "${BINARY_TEST_DIR}" ]] || { echo "BINARY_TEST_DIR is not set"; exit 1; }
rm -rf "${BINARY_TEST_DIR}/workspace-invalid-update"

WORKSPACE="${BINARY_TEST_DIR}/workspace-invalid-update"
BUNDLE_DIR="${WORKSPACE}/bundle"

# ---- create bundle: SHALLOW + UPDATE (invalid combination) ---
# ecbuild_critical fires before any git operation, so the URL need not exist.
mkdir -p "${BUNDLE_DIR}"
cat > "${BUNDLE_DIR}/CMakeLists.txt" <<EOF
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
find_package( ecbuild 3.12 REQUIRED HINTS ${CMAKE_SOURCE_DIR} )
project( umbrella-bundle LANGUAGES NONE )
ecbuild_bundle_initialize()
ecbuild_bundle(
  PROJECT umbrella
  GIT "file:///does-not-need-to-exist.git"
  BRANCH main
  SHALLOW
  UPDATE
)
ecbuild_bundle_finalize()
EOF

cat > "${BUNDLE_DIR}/VERSION" <<EOF
0.0.1
EOF

# ---- configure should FAIL with a clear error message --------
mkdir -p "${WORKSPACE}/build"
cd "${WORKSPACE}/build"

set +e
output=$( ecbuild --prefix="$(pwd)/install" -- "${BUNDLE_DIR}" 2>&1 )
cmake_status=$?
set -e

if [[ "${cmake_status}" -eq 0 ]]; then
    echo "cmake configure should have failed for SHALLOW+UPDATE but succeeded: FAIL"
    exit 1
fi

if echo "${output}" | grep -q "Cannot pass both UPDATE and SHALLOW"; then
    echo "SHALLOW+UPDATE correctly rejected: PASS"
else
    echo "cmake failed but expected error message not found: FAIL"
    echo "${output}"
    exit 1
fi

#!/usr/bin/env bash

set -euo pipefail

ECBUILD_PATH=${CMAKE_SOURCE_DIR}/bin
SOURCE_TEST_DIR=${CMAKE_CURRENT_SOURCE_DIR}
BINARY_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}

#
# Redirect HOME to a per-job temp directory so that every git process
# (including subprocesses spawned internally by git-submodule) reads a private
# ~/.gitconfig. This avoids lock contention on the real ~/.gitconfig when
# parallel CI jobs run, and works on all git versions.
#
# GIT_CONFIG_GLOBAL (requires git >= 2.32) and GIT_CONFIG_COUNT (not forwarded
# by git-submodule to its child processes) are not viable alternatives here.
#
# Required on git >= 2.38.1 and on distros that have backported CVE-2022-39253
# (e.g. Debian 11's git 2.30.2).
#
_tmp_home=$(mktemp -d)
export HOME="${_tmp_home}"
trap 'rm -rf "${_tmp_home}"' EXIT
pushd "${HOME}" > /dev/null
git config --global protocol.file.allow always
git config --global user.name  "Test User"
git config --global user.email "test@user"
popd > /dev/null

# Add ecbuild to path
export PATH=$ECBUILD_PATH:$PATH

# ---- cleanup -----------------------------------------
[[ -n "${BINARY_TEST_DIR}" ]] || { echo "BINARY_TEST_DIR is not set"; exit 1; }
rm -rf "${BINARY_TEST_DIR}/workspace-shallow-only"

WORKSPACE="${BINARY_TEST_DIR}/workspace-shallow-only"
BUNDLE_DIR="${WORKSPACE}/bundle"

# ---- setup umbrella project (with submodules) --------
cd "${BINARY_TEST_DIR}"
bash "${SOURCE_TEST_DIR}/setup-umbrella-project.sh" "${WORKSPACE}/projects"

BARE_DIR="${WORKSPACE}/bare-repos"
UMBRELLA_GIT="file://${BARE_DIR}/umbrella.git"

# ---- create bundle: SHALLOW only (no RECURSIVE) ------
mkdir -p "${BUNDLE_DIR}"
cat > "${BUNDLE_DIR}/CMakeLists.txt" <<EOF
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
find_package( ecbuild 3.12 REQUIRED HINTS ${CMAKE_SOURCE_DIR} )
project( umbrella-bundle LANGUAGES NONE )
ecbuild_bundle_initialize()
ecbuild_bundle(
  PROJECT umbrella
  GIT "${UMBRELLA_GIT}"
  BRANCH main
  SHALLOW
)
ecbuild_bundle_finalize()
EOF

cat > "${BUNDLE_DIR}/VERSION" <<EOF
0.0.1
EOF

# ---- configure umbrella bundle -----------------------
mkdir -p "${WORKSPACE}/build"
cd "${WORKSPACE}/build"
ecbuild --prefix="$(pwd)/install" -- "${BUNDLE_DIR}"

# ---- check: umbrella is shallow ----------------------
PASS=1

cd "${BUNDLE_DIR}/umbrella"
if [[ "$(git rev-parse --is-shallow-repository)" != "true" ]]; then
    echo "Umbrella is not shallow: FAIL"
    PASS=0
else
    echo "Umbrella is shallow: PASS"
fi

# ---- check: submodules are NOT initialised -----------
# Without RECURSIVE, ecbuild_git skips the submodule update step; the
# submodule directories should exist (as tracked gitlinks) but must not
# contain an initialised git repo (.git file/dir created by submodule init).
for sub in alpha beta gamma; do
    if [[ -e "${BUNDLE_DIR}/umbrella/${sub}/.git" ]]; then
        echo "Submodule ${sub} is initialised but RECURSIVE was not requested: FAIL"
        PASS=0
    else
        echo "Submodule ${sub} is not initialised: PASS"
    fi
done

exit $(( 1 - PASS ))

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# (1) Configure with default options, and then reconfigure with user specified options

mkdir -p $HERE/build_1
ecbuild $SOURCE/test_project -B $HERE/build_1 -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.a.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREA.*proja(ON): ''"
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREA.*projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREB.*proja(ON): ''" # Uses value specified at 'bundle' level
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREB.*projb(ON): ''"
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREC.*proja(OFF): ''"  # Uses value specified at 'bundle' level
EXPECT_ONE_OF $HERE/build_1.a.log "FEATUREC.*projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_1.a.log "Build files have been written"

ecbuild $SOURCE/test_project -B $HERE/build_1 -DENABLE_FEATUREA=ON -DENABLE_FEATUREB=OFF -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.b.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREA.*proja(ON): ''"
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREA.*projb(ON): ''"
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREB.*proja(OFF): ''"  # Uses value specified by 'CLI'
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREB.*projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREC.*proja(OFF): ''"  # Uses value specified at 'bundle' level
EXPECT_ONE_OF $HERE/build_1.b.log "FEATUREC.*projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_1.b.log "Build files have been written"

#!/bin/bash
set -e -o pipefail

{ set +x; } 2>/dev/null
HERE="$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"

function cleanup {
  EXIT_CODE=$?
  { set +ex; } 2>/dev/null
  if [[ -n $BUILD_DIR ]]; then
    set -x
    rm -Rf $BUILD_DIR
  fi
  exit $EXIT_CODE
}

trap cleanup EXIT

function build() {
    echo "build"
  export ecbuild_DIR=${HERE}/../..

  _NAME="$1"
  _SRC="$2"
  _CMAKE_FLAGS="$3"

  echo Building project ${_NAME}

  TMPDIR="${TMPDIR:-$(pwd)}"
  BUILD_DIR="${TMPDIR}/build_${_NAME}_$(date +%Y-%m-%d_%H-%M-%S)"

  set -x
  mkdir -p ${BUILD_DIR} && cd ${BUILD_DIR}
  cmake ${_CMAKE_FLAGS} ${HERE}/${_SRC}
  make ${MAKE_ARGS}
  ctest
}

#!/usr/bin/env bash

set -eux

SOURCE_DIR=$(pwd)
BUILD_DIR=build
ECBUILD_BIN=$SOURCE_DIR/bin/ecbuild

test -x $(which $ECBUILD_BIN)

rm -rf $BUILD_DIR
mkdir $BUILD_DIR
cd $BUILD_DIR

$ECBUILD_BIN --prefix=$PREFIX --log=DEBUG -- -DINSTALL_LIB_DIR=lib $SOURCE_DIR
make test -j $CPU_COUNT
make install

#!/usr/bin/env bash
set -ex

echo "HI"

TEST_ROOT="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

foo_src="$TEST_ROOT/libfoo"
project_src="$TEST_ROOT/project"
foo_install="$(pwd)/foo-install"
project_install="$(pwd)/project-install"

mkdir -p foo-{build,install}
cmake \
    -B foo-build \
    -S "$foo_src" \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX="$foo_install"
cmake --build foo-build --target install -j

mkdir -p project-{build,install}
cmake \
    -B project-build \
    -S "$project_src" \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX="$project_install" \
    -DCMAKE_PREFIX_PATH="$foo_install" \
    -Decbuild_ROOT="$TEST_ROOT/../../"
cmake --build project-build --target install -j

lib_file_count="$(find $(pwd)/project-install \( -type f -o -type l \) -name 'libfoo.*' | wc -l)"
if [[ ! "${lib_file_count}" -eq 3 ]]; then
        echo "ERROR: Install tree is not correct"
        exit 1
fi

random=$($project_install/bin/project)
if [[ ! "${random}" -eq 4 ]]; then
        echo "ERROR: project executable did run but did not output the expected value"
        exit 1
fi

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# (1) Configure with default options, and then reconfigure with user specified options

mkdir -p $HERE/build_1
ecbuild $SOURCE/test_project -B $HERE/build_1 -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.a.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.a.log "Feature FEATUREA disabled"
EXPECT_ONE_OF $HERE/build_1.a.log "Feature FEATUREB enabled"
EXPECT_ONE_OF $HERE/build_1.a.log "Build files have been written"
# Ensure the option values are correct in CMakeCache
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREA_defined_value:INTERNAL=OFF"
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREB_defined_value:INTERNAL=ON"

ecbuild $SOURCE/test_project -B $HERE/build_1 -DENABLE_FEATUREA=ON -DENABLE_FEATUREB=OFF -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.b.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.b.log "Feature FEATUREA enabled"
EXPECT_ONE_OF $HERE/build_1.b.log "Feature FEATUREB disabled"
EXPECT_ONE_OF $HERE/build_1.b.log "Build files have been written"
# Ensure the option values are correct in CMakeCache
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREA_defined_value:INTERNAL=ON"
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREB_defined_value:INTERNAL=OFF"

ecbuild $SOURCE/test_project -B $HERE/build_1 -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.c.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.c.log "Feature FEATUREA enabled"
EXPECT_ONE_OF $HERE/build_1.c.log "Feature FEATUREB disabled"
EXPECT_ONE_OF $HERE/build_1.c.log "Build files have been written"
# Ensure the option values are correct in CMakeCache
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREA_defined_value:INTERNAL=ON"
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREB_defined_value:INTERNAL=OFF"

ecbuild $SOURCE/test_project -B $HERE/build_1 -DENABLE_FEATUREA=OFF -DENABLE_FEATUREB=ON -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.d.log
# Ensure the option values are correct in CMake output
EXPECT_ONE_OF $HERE/build_1.d.log "Feature FEATUREA disabled"
EXPECT_ONE_OF $HERE/build_1.d.log "Feature FEATUREB enabled"
EXPECT_ONE_OF $HERE/build_1.d.log "Build files have been written"
# Ensure the option values are correct in CMakeCache
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREA_defined_value:INTERNAL=OFF"
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREB_defined_value:INTERNAL=ON"

ecbuild $SOURCE/test_project -B $HERE/build_1 -DECBUILD_LOG_LEVEL=DEBUG | tee $HERE/build_1.e.log
EXPECT_ONE_OF $HERE/build_1.e.log "Feature FEATUREA disabled"
EXPECT_ONE_OF $HERE/build_1.e.log "Feature FEATUREB enabled"
EXPECT_ONE_OF $HERE/build_1.e.log "Build files have been written"
# Ensure the option values are correct in CMakeCache
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREA_defined_value:INTERNAL=OFF"
EXPECT_ONE_OF $HERE/build_1/CMakeCache.txt "project_ENABLE_FEATUREB_defined_value:INTERNAL=ON"

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# Options: (defaults)
 
mkdir -p $HERE/build_0
ecbuild $SOURCE/test_project -B $HERE/build_0 | tee $HERE/build_0.log
EXPECT_ONE_OF $HERE/build_0.log "* FEATURE_A, proja(ON): '', projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_0.log "* FEATURE_B, projb(OFF): ''"
EXPECT_ONE_OF $HERE/build_0.log "* FEATURE_C, projc(OFF): ''"
EXPECT_ONE_OF $HERE/build_0.log "Build files have been written"

# Options: -DENABLE_FEATURE_A=ON

mkdir -p $HERE/build_1
ecbuild -DENABLE_FEATURE_A=ON $SOURCE/test_project -B $HERE/build_1 | tee $HERE/build_1.log
EXPECT_ONE_OF $HERE/build_1.log "* FEATURE_A, proja(ON): '', projb(ON): ''"

# Options: -DENABLE_FEATURE_A=ON -DPROJB_ENABLE_FEATURE_A=OFF

mkdir -p $HERE/build_2
ecbuild -DENABLE_FEATURE_A=ON -DPROJB_ENABLE_FEATURE_A=OFF $SOURCE/test_project -B $HERE/build_2 | tee $HERE/build_2.log
EXPECT_ONE_OF $HERE/build_2.log "* FEATURE_A, proja(ON): '', projb(OFF): ''"

# Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=OFF
 
mkdir -p $HERE/build_3
ecbuild -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=OFF $SOURCE/test_project -B $HERE/build_3 | tee $HERE/build_3.log
EXPECT_ONE_OF $HERE/build_3.log "* FEATURE_A, proja(OFF): '', projb(ON): ''"
EXPECT_ONE_OF $HERE/build_3.log "* FEATURE_B, projb(OFF): ''"

# Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON
 
mkdir -p $HERE/build_4
ecbuild -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DSOME_PACKAGE_FOUND=ON $SOURCE/test_project -B $HERE/build_4 | tee $HERE/build_4.log
EXPECT_ONE_OF $HERE/build_4.log "* FEATURE_A, proja(OFF): '', projb(ON): ''"
EXPECT_ONE_OF $HERE/build_4.log "* FEATURE_B, projb(ON): ''"

# Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DENABLE_FEATURE_B=ON -DSOME_PACKAGE_FOUND=ON
 
mkdir -p $HERE/build_5
ecbuild -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DENABLE_FEATURE_B=ON -DSOME_PACKAGE_FOUND=ON $SOURCE/test_project -B $HERE/build_5 | tee $HERE/build_5.log
EXPECT_ONE_OF $HERE/build_5.log "* FEATURE_A, proja(OFF): '', projb(ON): ''"
EXPECT_ONE_OF $HERE/build_5.log "* FEATURE_B, projb(ON): ''"

# Options: -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DENABLE_FEATURE_B=ON -DSOME_PACKAGE_FOUND=OFF
 
mkdir -p $HERE/build_6
ecbuild -DENABLE_FEATURE_A=OFF -DPROJB_ENABLE_FEATURE_A=ON -DENABLE_FEATURE_B=ON -DSOME_PACKAGE_FOUND=OFF $SOURCE/test_project -B $HERE/build_6 | tee $HERE/build_6.log
EXPECT_ONE_OF $HERE/build_6.log "Configuring incomplete, errors occurred!"

#!/usr/bin/env bash

set -e

HERE="$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"

# Add ecbuild to path
export PATH=$HERE/../../bin:$PATH

# --------------------- cleanup ------------------------
$HERE/clean.sh

# ----------------- build projectA ---------------------
cd $HERE/projectA

mkdir build
cd build
ecbuild --prefix=../install -- -DINSTALL_LIB_DIR=lib -Wno-deprecated ../
make install

# ----------------- build projectB ---------------------
cd $HERE/projectB

mkdir build
cd build
ecbuild --prefix=../install -- \
    -DprojectA_DIR=$HERE/projectA/install/lib/cmake/projectA \
    -DINSTALL_LIB_DIR=lib -Wno-deprecated ../
make install

# ----------------- build projectC ---------------------
cd $HERE/projectC

mkdir build
cd build
ecbuild --prefix=../install -- \
    -DprojectA_DIR=$HERE/projectA/install/lib/cmake/projectA \
    -DprojectB_DIR=$HERE/projectB/install/lib/cmake/projectB \
    -DINSTALL_LIB_DIR=lib -Wno-deprecated ../
make install

# ----------------- Run ---------------------

cd $HERE
projectC/install/bin/main-C

#!/usr/bin/env bash

set -e

HERE="$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"

# --------------------- cleanup ------------------------

rm -rf projectA/build
rm -rf projectA/install
rm -rf projectB/build
rm -rf projectB/install
rm -rf projectC/build
rm -rf projectC/install

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

run_test_ECBUILD_2_COMPAT() {
    local tname=ECBUILD_2_COMPAT__$1
    local exp_sts=$2
    shift 2

    local bdir=$HERE/build_$tname
    local logf=$HERE/$tname.log

    mkdir -p $bdir && cd $bdir
    local sts=0
    echo "Running test '$tname'"
    ecbuild -- -DECBUILD_2_COMPAT=ON -Wno-deprecated $* $SOURCE/test_project >$logf 2>&1 || sts=$?

    if [[ $sts -ne $exp_sts ]] ; then
        echo "Test '$tname': expected exit code $exp_sts, got $sts"
        cat $logf
        exit 1
    fi
}

run_test() {

    run_test_ECBUILD_2_COMPAT "$@"

    local tname=$1
    local exp_sts=$2
    shift 2

    local bdir=$HERE/build_$tname
    local logf=$HERE/$tname.log

    mkdir -p $bdir && cd $bdir
    local sts=0
    echo "Running test '$tname'"
    ecbuild -- -Wno-deprecated $* $SOURCE/test_project >$logf 2>&1 || sts=$?

    if [[ $sts -ne $exp_sts ]] ; then
        echo "Test '$tname': expected exit code $exp_sts, got $sts"
        cat $logf
        exit 1
    fi
}

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ---------------------- tests -------------------------
run_test all_def 0 \
    -DEXPECT_TEST_A=ON -DEXPECT_TEST_B=ON -DEXPECT_TEST_C=OFF -DEXPECT_TEST_D=ON -DEXPECT_TEST_E=OFF -DEXPECT_TEST_F=ON -DEXPECT_TEST_G=OFF \
    -DEXPECT_TEST_H=ON -DEXPECT_TEST_I=ON -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test all_off 0 \
    -DENABLE_TEST_A=OFF -DENABLE_TEST_B=OFF -DENABLE_TEST_C=OFF -DENABLE_TEST_D=OFF -DENABLE_TEST_E=OFF -DENABLE_TEST_F=OFF -DENABLE_TEST_G=OFF \
    -DEXPECT_TEST_A=OFF -DEXPECT_TEST_B=OFF -DEXPECT_TEST_C=OFF -DEXPECT_TEST_D=OFF -DEXPECT_TEST_E=OFF -DEXPECT_TEST_F=OFF -DEXPECT_TEST_G=OFF \
    -DENABLE_TEST_H=OFF -DENABLE_TEST_I=OFF -DENABLE_TEST_J=OFF -DENABLE_TEST_K=OFF \
    -DEXPECT_TEST_H=OFF -DEXPECT_TEST_I=OFF -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test ok_on 0 \
    -DENABLE_TEST_A=ON -DENABLE_TEST_B=ON -DENABLE_TEST_C=ON -DENABLE_TEST_D=ON -DENABLE_TEST_F=ON \
    -DEXPECT_TEST_A=ON -DEXPECT_TEST_B=ON -DEXPECT_TEST_C=ON -DEXPECT_TEST_D=ON -DEXPECT_TEST_F=ON -DEXPECT_TEST_E=OFF -DEXPECT_TEST_G=OFF \
    -DEXPECT_TEST_H=ON -DEXPECT_TEST_I=ON -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test fail_pkg_E 1 -DENABLE_TEST_E=ON
run_test fail_cond_G 1 -DENABLE_TEST_G=ON
run_test fail_pkg_J 1 -DENABLE_TEST_J=ON
run_test fail_pkg_K 1 -DENABLE_TEST_K=ON

#!/usr/bin/env bash

set -e
set -x

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

function assert_flag() {
  local file=$1
  local variable=$2
  local flag=$3
  local found=$(grep "${variable} = " ${file} | grep "\\${flag}" | wc -l)

  if [ $found -ne 1 ]; then
      echo "File ${file} does not contain exacly one of '$3'"
      exit 1
  fi
}

# 1) Build the project -- using toolchain

mkdir -p $HERE/build-1
cd $HERE/build-1
cmake $SOURCE/test_project \
  -DCMAKE_BUILD_TYPE=CUSTOM \
  -DCMAKE_TOOLCHAIN_FILE=$SOURCE/toolchain.cmake

# Check that the flags are correctly set for Fortran, C and C++

assert_flag CMakeFiles/proj_f.dir/flags.make "Fortran_FLAGS" "-Wno-common-f-flag"
assert_flag CMakeFiles/proj_f.dir/flags.make "Fortran_FLAGS" "-Wno-custom-f-flag"

assert_flag CMakeFiles/proj_c.dir/flags.make "C_FLAGS" "-Wno-common-c-flag"
assert_flag CMakeFiles/proj_c.dir/flags.make "C_FLAGS" "-Wno-custom-c-flag"

assert_flag CMakeFiles/proj_cxx.dir/flags.make "CXX_FLAGS" "-Wno-common-cxx-flag"
assert_flag CMakeFiles/proj_cxx.dir/flags.make "CXX_FLAGS" "-Wno-custom-cxx-flag"

# 2) Build the project -- using explicit ECBUILD_*_FLAGS_<type> variables

mkdir -p $HERE/build-2
cd $HERE/build-2
cmake $SOURCE/test_project \
  -DCMAKE_BUILD_TYPE=CUSTOM \
  -DECBUILD_Fortran_FLAGS="-Wno-common-f-flag" \
  -DECBUILD_C_FLAGS="-Wno-common-c-flag" \
  -DECBUILD_CXX_FLAGS="-Wno-common-cxx-flag" \
  -DECBUILD_Fortran_FLAGS_CUSTOM="-Wno-custom-f-flag" \
  -DECBUILD_C_FLAGS_CUSTOM="-Wno-custom-c-flag" \
  -DECBUILD_CXX_FLAGS_CUSTOM="-Wno-custom-cxx-flag"

# Check that the flags are correctly set for Fortran, C and C++

assert_flag CMakeFiles/proj_f.dir/flags.make "Fortran_FLAGS" "-Wno-common-f-flag"
assert_flag CMakeFiles/proj_f.dir/flags.make "Fortran_FLAGS" "-Wno-custom-f-flag"

assert_flag CMakeFiles/proj_c.dir/flags.make "C_FLAGS" "-Wno-common-c-flag"
assert_flag CMakeFiles/proj_c.dir/flags.make "C_FLAGS" "-Wno-custom-c-flag"

assert_flag CMakeFiles/proj_cxx.dir/flags.make "CXX_FLAGS" "-Wno-common-cxx-flag"
assert_flag CMakeFiles/proj_cxx.dir/flags.make "CXX_FLAGS" "-Wno-custom-cxx-flag"

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# Ensure Python 3.x is available
# This effectively asserts that a working python3 exists, otherwise the script will fail here
python3 --version

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

TC=1
mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/interpreter_and_libs_project -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

TC=2
mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/interpreter_and_libs_with_version_project -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

TC=3
mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/interpreter_only_project -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

TC=4
mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/interpreter_only_with_version_project -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

TC=5
mkdir -p $HERE/build_${TC}
ecbuild $SOURCE/nonexistent_version_project -B $HERE/build_${TC} | tee $HERE/build_${TC}.log
EXPECT_ONE_OF $HERE/build_${TC}.log "Build files have been written"

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# Build the project
ecbuild $SOURCE/test_project -B $HERE/build

# Run only one specific test (which should invoke the others)
(cd $HERE/build; ctest -R write_world_after_hello)  # Avoid using --test-dir option in ctest

# Check if the output is as expected
echo -n "Hello, World!" | diff - $HERE/build/output.txt

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

check_lib_exists() {

  local libname=$1
  local ext=$2

  if [ ! -f $HERE/build/lib/lib${libname}.$ext ]; then
     echo "$HERE/build/lib/lib${libname}.$ext not found"
     exit 1 
  fi

}

dyn_ext="so"
if [[ $(uname) == "Darwin" ]]; then
  dyn_ext="dylib"
fi
static_ext="a"

logf=$HERE/test_ecbuild_shared_libs.log

# enable shared libraries across project
$SOURCE/clean.sh
ecbuild -DENABLE_TESTS=OFF -DTEST_SHARED_LIBS_BUILD_SHARED_LIBS=OFF $SOURCE/test_project -B $HERE/build
cmake --build build
check_lib_exists test_shared_libs ${static_ext}
check_lib_exists lib2 ${static_ext}
check_lib_exists lib1 ${dyn_ext}

# test that BUILD_SHARED_LIBS is overriden
$SOURCE/clean.sh
ecbuild -DENABLE_TESTS=OFF -DTEST_SHARED_LIBS_BUILD_SHARED_LIBS=OFF -DBUILD_SHARED_LIBS=ON $SOURCE/test_project -B $HERE/build
cmake --build build
check_lib_exists test_shared_libs ${static_ext}
check_lib_exists lib2 ${static_ext}
check_lib_exists lib1 ${dyn_ext}

# test ecbuild failure for invalid argument
$SOURCE/clean.sh
ecbuild -DENABLE_TESTS=OFF -DTEST_SHARED_LIBS_BUILD_SHARED_LIBS=SHARED $SOURCE/test_project -B $HERE/build >$logf 2>&1 || result=$?
if [ ! $result ]; then
   echo "ecbuild should have failed for invalid argument"
   cat $logf
   exit 1
fi

# enable target specific override 1
$SOURCE/clean.sh
ecbuild -DENABLE_TESTS=OFF -DECBUILD_TARGET_test_shared_libs_TYPE=SHARED -DBUILD_SHARED_LIBS=OFF $SOURCE/test_project -B $HERE/build
cmake --build build
check_lib_exists test_shared_libs ${dyn_ext}
check_lib_exists lib2 ${static_ext}
check_lib_exists lib1 ${dyn_ext}

# enable target specific override 2
$SOURCE/clean.sh
ecbuild -DENABLE_TESTS=OFF -DECBUILD_TARGET_test_shared_libs_TYPE=STATIC $SOURCE/test_project -B $HERE/build
cmake --build build
check_lib_exists test_shared_libs ${static_ext}
check_lib_exists lib2 ${dyn_ext}
check_lib_exists lib1 ${dyn_ext}

#!/usr/bin/env bash

set -e

function EXPECT_ONE_OF()
{
    local file=$1
    local pattern=$2
    local found=$(cat ${file} | grep "${pattern}" | wc -l | xargs)

    if [ "$found" != "1" ]; then
        echo "File ${file} does not contain exacly one of '$2'"
        exit 1
    fi
}

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ----------------- configure project ---------------------

# (1) Options: (default)

mkdir -p $HERE/build_1
ecbuild $SOURCE/test_project -B $HERE/build_1 | tee $HERE/build_1.log
EXPECT_ONE_OF $HERE/build_1.log "Feature FEATUREON was not enabled"
EXPECT_ONE_OF $HERE/build_1.log "Feature FEATUREOFF disabled"
EXPECT_ONE_OF $HERE/build_1.log "Build files have been written"

# (2) Options: -DENABLE_FEATUREON=ON

mkdir -p $HERE/build_2
ecbuild -DENABLE_FEATUREON=ON $SOURCE/test_project -B $HERE/build_2 | tee $HERE/build_2.log
EXPECT_ONE_OF $HERE/build_2.log "Configuring incomplete, errors occurred!"

# (2a) Options: -DENABLE_FEATUREON=OFF

mkdir -p $HERE/build_2a
ecbuild -DENABLE_FEATUREON=OFF $SOURCE/test_project -B $HERE/build_2a | tee $HERE/build_2a.log
EXPECT_ONE_OF $HERE/build_2a.log "Feature FEATUREON disabled"
EXPECT_ONE_OF $HERE/build_2a.log "Feature FEATUREOFF disabled"
EXPECT_ONE_OF $HERE/build_2a.log "Build files have been written"

# (3) Options: -DENABLE_FEATUREON=ON -DFEATUREON_CONDITION=ON
 
mkdir -p $HERE/build_3
ecbuild -DENABLE_FEATUREON=ON -DFEATUREON_CONDITION=ON $SOURCE/test_project -B $HERE/build_3 | tee $HERE/build_3.log
EXPECT_ONE_OF $HERE/build_3.log "Feature FEATUREON enabled"
EXPECT_ONE_OF $HERE/build_3.log "Feature FEATUREOFF disabled"
EXPECT_ONE_OF $HERE/build_3.log "Build files have been written"

# (4) Options: -DPROJA_ENABLE_FEATUREON=ON

mkdir -p $HERE/build_4
ecbuild -DPROJA_ENABLE_FEATUREON=ON $SOURCE/test_project -B $HERE/build_4 | tee $HERE/build_4.log
EXPECT_ONE_OF $HERE/build_4.log "Configuring incomplete, errors occurred!"

# (4a) Options: -DPROJA_ENABLE_FEATUREON=OFF

mkdir -p $HERE/build_4a
ecbuild -DPROJA_ENABLE_FEATUREON=OFF $SOURCE/test_project -B $HERE/build_4a | tee $HERE/build_4a.log
EXPECT_ONE_OF $HERE/build_4a.log "Feature FEATUREON disabled"
EXPECT_ONE_OF $HERE/build_4a.log "Feature FEATUREOFF disabled"
EXPECT_ONE_OF $HERE/build_4a.log "Build files have been written"

# (5) Options: -DPROJA_ENABLE_FEATUREON=ON -DFEATUREON_CONDITION=ON -DENABLE_FEATUREON=OFF

mkdir -p $HERE/build_5
ecbuild -DPROJA_ENABLE_FEATUREON=ON -DFEATUREON_CONDITION=ON -DENABLE_FEATUREON=OFF $SOURCE/test_project -B $HERE/build_5 | tee $HERE/build_5.log
EXPECT_ONE_OF $HERE/build_5.log "Feature FEATUREON enabled"
EXPECT_ONE_OF $HERE/build_5.log "Feature FEATUREOFF disabled"
EXPECT_ONE_OF $HERE/build_5.log "Build files have been written"

# (6) Options: -DPROJA_ENABLE_FEATUREOFF=ON

mkdir -p $HERE/build_6
ecbuild -DPROJA_ENABLE_FEATUREOFF=ON $SOURCE/test_project -B $HERE/build_6 | tee $HERE/build_6.log
EXPECT_ONE_OF $HERE/build_6.log "Configuring incomplete, errors occurred!"

# (7) Options: -DPROJA_ENABLE_FEATUREOFF=ON -DFEATUREOFF_CONDITION=ON

mkdir -p $HERE/build_7
ecbuild -DPROJA_ENABLE_FEATUREOFF=ON -DFEATUREOFF_CONDITION=ON $SOURCE/test_project -B $HERE/build_7 | tee $HERE/build_7.log
EXPECT_ONE_OF $HERE/build_7.log "Feature FEATUREON was not enabled"
EXPECT_ONE_OF $HERE/build_7.log "Feature FEATUREOFF enabled"
EXPECT_ONE_OF $HERE/build_7.log "Build files have been written"

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

export PATH=$SOURCE/../../bin:$PATH

rm -rf $HERE/build
ecbuild $SOURCE/test_project -B $HERE/build
cmake --build $HERE/build --parallel ${CPU_COUNT:-2}
(cd $HERE/build; ctest --output-on-failure)

#!/usr/bin/env bash

set -e

HERE=${CMAKE_CURRENT_BINARY_DIR:-"$( cd $( dirname "${BASH_SOURCE[0]}" ) && pwd -P )"}
SOURCE=${CMAKE_CURRENT_SOURCE_DIR:-$HERE}

# Add ecbuild to path
export PATH=$SOURCE/../../bin:$PATH
echo $PATH
echo $SOURCE

run_test() {

    local tname=$1
    local exp_sts=$2
    shift 2

    local bdir=$HERE/build_$tname
    local logf=$HERE/$tname.log

    mkdir -p $bdir && cd $bdir
    local sts=0
    echo "Running test '$tname'"
    ecbuild -- -Wno-deprecated $* $SOURCE/test_project >$logf 2>&1 || sts=$?

    if [[ $sts -ne $exp_sts ]] ; then
        echo "Test '$tname': expected exit code $exp_sts, got $sts"
        cat $logf
        exit 1
    fi
}

# --------------------- cleanup ------------------------
$SOURCE/clean.sh

# ---------------------- tests -------------------------
run_test all_def 0 \
    -DEXPECT_TEST_A=ON -DEXPECT_TEST_B=ON -DEXPECT_TEST_C=OFF -DEXPECT_TEST_D=ON -DEXPECT_TEST_E=OFF -DEXPECT_TEST_F=ON -DEXPECT_TEST_G=OFF \
    -DEXPECT_TEST_H=ON -DEXPECT_TEST_I=ON -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test all_off 0 \
    -DENABLE_TEST_A=OFF -DENABLE_TEST_B=OFF -DENABLE_TEST_C=OFF -DENABLE_TEST_D=OFF -DENABLE_TEST_E=OFF -DENABLE_TEST_F=OFF -DENABLE_TEST_G=OFF \
    -DEXPECT_TEST_A=OFF -DEXPECT_TEST_B=OFF -DEXPECT_TEST_C=OFF -DEXPECT_TEST_D=OFF -DEXPECT_TEST_E=OFF -DEXPECT_TEST_F=OFF -DEXPECT_TEST_G=OFF \
    -DENABLE_TEST_H=OFF -DENABLE_TEST_I=OFF -DENABLE_TEST_J=OFF -DENABLE_TEST_K=OFF \
    -DEXPECT_TEST_H=OFF -DEXPECT_TEST_I=OFF -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test ok_on 0 \
    -DENABLE_TEST_A=ON -DENABLE_TEST_B=ON -DENABLE_TEST_C=ON -DENABLE_TEST_D=ON -DENABLE_TEST_F=ON \
    -DEXPECT_TEST_A=ON -DEXPECT_TEST_B=ON -DEXPECT_TEST_C=ON -DEXPECT_TEST_D=ON -DEXPECT_TEST_F=ON -DEXPECT_TEST_E=OFF -DEXPECT_TEST_G=OFF \
    -DEXPECT_TEST_H=ON -DEXPECT_TEST_I=ON -DEXPECT_TEST_J=OFF -DEXPECT_TEST_K=OFF

run_test fail_pkg_E 1 -DENABLE_TEST_E=ON
run_test fail_cond_G 1 -DENABLE_TEST_G=ON
run_test fail_pkg_J 1 -DENABLE_TEST_J=ON
run_test fail_pkg_K 1 -DENABLE_TEST_K=ON
